/*------------------------------------------- 
  Taskset 0,1,2 are constant execution time 
  tasks with different utilizations
--------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <math.h>
#include "my_threads.h"

int pat=-1;

unsigned long long max_loop=50000;
unsigned long long hyperP;

//unsigned long  long base = 100;        /* best, median2 cc/WCET, for max_loop=100000 */
unsigned long long base=13000;             

float AVG;
float AMP;

static unsigned int load = 2;

/* mul: WCET of the thread */
void aThread(int mul)
{

       unsigned long long i,j, maxlp;
        long ptn=-1;
        float step=0.0;

       volatile int chars = 0;
       FILE *fptr; 
       char st[30];


        while(1)
        {

          switch(pat){
          case CONST_PTN:
            maxlp=mul*max_loop;
            break;
          case EXP_PTN:
            ptn++;
            if(ptn% MAX_PTN==0){
              maxlp=mul*max_loop;
              ptn=0;
            }else
              maxlp=mul*max_loop*pow(BASE_PTN, ptn);
            break;
          case HALF_SIN_PTN:

            ptn++;
            if(ptn% MAX_PTN==0){
              maxlp=mul*max_loop;
              ptn=0;
            }else
              maxlp=mul*max_loop*sin((((float)ptn/12.0)+1)*1.5707963);
            break;
          case SIN_PTN:

            maxlp=((float)(mul*max_loop)*AVG)+((float)(mul*max_loop)*AMP)*sin(step+1.5707963);
            step+=0.2;
            break;
          }

          if (load == 1)
          {
            fptr = fopen("Reading","r");
            maxlp = maxlp / 50;
          }

          for ( i = 0; i <maxlp; i++ )
          {
            if (load == 1)
            {
              if (fscanf(fptr,"%s",st)!=EOF) 
                chars++;
              else
                fseek(fptr, 0, SEEK_SET);
            }
            else
            {
              /* No-op */
            }
          }

          if (load == 1)
            fclose(fptr);

          threadYield();
        }





}



void thread0()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=95*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}


void thread1()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=35*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}



void thread2()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=35*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}


void thread3()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=15*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}


void thread4()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=245*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread5()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=35*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread6()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=85*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread7()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread8()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=20*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread9()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=155*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread10()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=115*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread11()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=65*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread12()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread13()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=65*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread14()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread15()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=45*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread16()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread17()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=235*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread18()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=20*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread19()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=15*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread20()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=35*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread21()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=65*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread22()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=85*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread23()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread24()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=5*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread25()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=155*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread26()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=165*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread27()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=45*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread28()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=45*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}

void thread29()
{
	unsigned long long i,j, maxlp;

	while(1)
	{
	    maxlp=85*max_loop;
	  
	  for ( i = 0; i < maxlp; i++ )
	    {
	      j = j*i; 
	    }
	  
	  threadYield();
	}
}





void idlethread(int mul)
{
	while(1) {}
}



void printfHelp( char * argv[])
{

          printf("Usage: %s {DVS} {task num.} {worst case utilization} {n} {baseline} {pattern} {load}\n",argv[0]);
          printf("    DVS: the DVS algorithm to use\n");
          printf("\t0: static\n");
          printf("\t1: cycle conserving\n");
          printf("\t2: look-ahead\n");
          printf("\t3: feedback-DVS\n");
	  printf("\t4: Aydin's aggressive AGR DVS\n");
	  printf("\t5: Aydin's DR_OTE DVS\n");
	  printf("\t6: naive DVS\n");
	  printf("\t7: original look-ahead\n");
	  printf("    task num:\n");
	  printf("\t : number of tasks in the task set\n");
          printf("    worst case utilization:\n");
          printf("\t1: WCET Utilization=0.1\n");
	  printf("\t2: WCET Utilization=0.2\n");
	  printf("\t   ...\n");
	  printf("\t9: WCET Utilization=0.9\n");
          printf("    n:\n");
          printf("\tProgram stops after n hyperperiod\n");
	  printf("    baseline:\n");
	  printf("\t0: avg.cc/WCET=0.30, amplitude=0.20\n");
	  printf("\t1: avg.cc/WCET=0.50, amplitude=0.30\n");
	  printf("\t2: avg.cc/WCET=0.75, amplitude=0.20\n");
	  printf("    pattern:\n");
	  printf("\t0: constant exec. time\n");
	  printf("\t1: fluctuating exec. time - exponential\n");
	  printf("\t2: fluctuating exec. time - half-sine\n");
	  printf("\t3: fluctuating exec. time - sine\n");
	  printf("    type of test load:\n");
	  printf("\t0: CPU intensive\n");
	  printf("\t1: Memory intensive\n");
	  printf("\t2: CPU/Memory intensive\n");
          exit(0);
}






int main(int argc, char* argv[])
{
  struct timeval itm1, itm2;
  
  int taskset=0;
  int n;
  int i,j,k;
  int baseline;
  float U;
  int taskNum;
  pid_t pid;
  long total=0;

#ifdef GETPID_DEBUG
  struct timeval tv1,tv2;
  for(i=0;i<100;i++){
    gettimeofday(&tv1, NULL);
    pid=getpid();
    gettimeofday(&tv2, NULL);
    total+=tv2.tv_sec*1000000+tv2.tv_usec-tv1.tv_sec*1000000-tv1.tv_usec;
  }
  printf("avg getpid() time=%f usec\n", (float)total/100.0);
  return 0;
#endif

  srandom(0);

  if(argc !=8){
    printfHelp(argv);
  }	

  DVS = atoi(argv[1]);
  taskNum=atoi(argv[2]);
  taskset = atoi(argv[3]);
  n=atoi(argv[4]);
  baseline=atoi(argv[5]);
  pat=atoi(argv[6]);
  load = atoi(argv[7]);

  if(DVS <0  || taskNum<=0 || taskset <=0  || n <=0 || pat<0 || pat>3)
    {
      printfHelp(argv);
    }
		      
	
  switch (baseline){
  case 0: AVG=0.3; AMP=0.2; break;
  case 1: AVG=0.5; AMP=0.2;break;
  case 2: AVG=0.75; AMP=0.2;break;
  default: printfHelp(argv);
  }
  


		      

#ifdef SYNC   

	/* initilization signal */
	/* set voltage = 1500mV.
	 * Note: 1500mV is only used
	 * to signal the start/end 
	 * of system execution. It is
	 * not used during scheduling. 
	 */  
	my_set_freq("200/100/24");    
#else
	my_set_freq(100);      
#endif
	for (i=0;i<355;i++){
	  for(j=0;j<500;j++){
	  k=k*2;
	  }}

	/* Initialize the thread library */
	initThreads();

/*        for (i=0;i<355;i++){
          for(j=0;j<500;j++){
          k=k*2;
          }}*/

	/* Go threads! */
	U=(float)taskset/10.0;
	spawnMultiThd(&aThread, taskNum, U,AVG, base, load);
	hyperP=base*1000;
	
	printf("hyperPeriod=%.4fms, runs for %d hyperPeriod\n", (float)hyperP/1000.00, n);
	hyperP=n*hyperP;

	/* start scheduling and running the threads */
	spawnThreadArg( &idlethread, 0, 0,0); /* idle task */
	Start();

	return 0;
}
